\pm Custom Help \ General
\p General \ Use And Distribution


	CH is Copyright (c) 1991 by William J. Fritz

	CH is a copyrighted program that is provided "as is". There is no\
warranty, either expressed or implied, as to the quality or usefullness\
of the program. The user of the program accepts all risks associated with\
it's use.

	CH is shareware. The suggested donation is $25. If you find yourself\
using this program and you think the effort used to develop it are worth\
a donation, send it to the author:

	William J. Fritz
	4504 E. Yates Rd.
	Bensalem, Pa. 19020
	215-245-1584
	GEnie electronic mail address W.FRITZ1


	CH is freely distributable provided:

	1. The files are all left intact.

	2. No charge is made for CH (other than a reasonable copy charge of
		$6.00 or less)

	3. CH is not packaged as a part of a commercial product.

	4. CH is not uploaded to any electronic service that claims a
		copyright to it's files or programs.

\p System Requirements


1. Memory:	Approximately 66k (more depending on the
				size of the Data Files loaded).

2. Version:	WorkBench 1.3 and later.

\p Using This Document


	Key combinations are presented as a qualifier, a dash, then the key\
name in capitals (sc-RETURN for shift-control-RETURN).

	In this document, when I refer to Instructions I mean the actual\
operations that the program performs. Commands are the\
keystroke or series of keystrokes that initiate the instruction.\
Commands are user definable, so when an Instruction is described\
the Command is not given.

	Press the HELP key at any time the Display Window is open to get\
a full list of Instructions and their associated Commands.

	Capitalized terms in this document can be found in the Glossary.\
Use the glossary for any unfamilar terms found here. The\
first time you display the glossary page, set a Mark there.\
The next time you need to access the glossary execute the Display Mark\
Instruction, after looking up the unfamiliar term execute the Last History\
Page Instruction to return to the page you were reading when you\
accessed the glossary with a Mark Display.

Abbreviations:
	CH: Custom Help
	AMP: Automatic Menu Page
	DW: Display Window
\r\Glossary

\p Purpose


	CH (Custom Help) is designed to provide an easily displayable help\
window with information supplied and organized by the user. This can be\
useful for any program that does not provide "on-line" help or just\
general information that you want to keep readily available.

	This is especially useful for those shareware and public domain\
programs (such as CH) that provide all their documentation on disk.\
By breaking down a large file into pages you can have menus and sub-menus\
that allow you easy access to any page in the document.

	Files are formatted by the user to determine the hierarchy of the\
data contained in the files and set up Related Item links.

	CH can also be used to display unformatted ASCII Text Files.

	Since I started CH my Data Files have constantly grown, and become\
more useful. Whenever I need some new information that I may be refering\
to again I create a new file. I now have about 2 meg of files gathered\
in this way. I keep all the information I need for programming in ".ch"\
files (Data Files) and have little need to open a book for reference\
to Amiga ROM Kernels, structures, etc. The ROM Kernels are available\
from Commodore in the developers update and can be converted for use by\
CH. As your data base grows a hard disk becomes very useful.

	I will be sending this program with only the Custom Help manual.\
Anyone with his\
own public domain or shareware program who would like to use CH for his\
documentation should feel free to format his document file for CH, create\
a Base File for it and send a copy of CH with his program.

\p Highlights


	note: Use the Related Item Instruction to get more details.


	Executable from either a CLI or WorkBench.

	Runs in the background when not needed.

	Configurable Hot Key to open the Display Window.
\r\Start/Startup Options

	Provides easy access to a large information base.

	Easily expandable with formatted files.
\l6	Just add a Base File and a configured Data File to the CH Directory,\
then start or re-start CH.
\l
	Configurable Commands.
\r\Using/Commands

	Quick Commands -- execute Instructions with a single keystroke.

	Optional, configurable menus.
\r\Files/CH.menu

	Mouse not necessary (except for proportional gadgets), but may be used.
\l6	All Commands can be executed from the keyboard. Where intuition\
gadgets are used a highlight box will appear around the first gadget.\
Use the RETURN key to make that gadget active. Enter your input, then\
press RETURN again to accept the input and the gadget becomes in-active.\
Use the arrow keys to move the highlight box to the next or previous\
gadget when the highlight gadget is not active.
\l
	Export function.
\l6	Export a page or a group to the printer or a file. Uses it's own\
left and right margins for Exported data, speerate from the Display Window\
margins. Convert style special characters to printer escape codes.
\l
\r\Using/Export Facility
	Set up to ten Marks
\l6	Setting a Mark will have the program save the currently viewed page\
and line. Easy access back to that location at any time thereafter.
\l
\r\Using/Marks
	Related Items
\l6	Set up links between pages for easy jumps between non-contiguous\
pages. Linked pages may be anywhere in the hierarchal system of pages.
\l
\r\Using/Related Items
	Ten page History Buffer
\l6	The last ten pages accessed will be saved. Makes it easy to return\
to a previous page after displaying a Mark, Search Page Instruction,\
Related Item Instruction, etc.
\l
\r\Using/History Buffer
	Multiple level Page Search by Page Name.
\r\Using/Page Search

	Word Search.
\r\Using/Word Search

	Word Wrap and font style definitions.
\r\Files/Word Wrap Specifiers
\r\Files/Text Style Characters

	Three methods of scrolling -- mouse, arrow keys and proportional gadget.
\r\Using/Scrolling within a page

	Smooth scrolling -- to read while scrolling.

	View any ASCII text file.
\r\Using/Text Files

	Open it's own screen
\l6	The CH screen uses your WorkBench overcan rows and columns to determine\
it's size. Set your own colors. Use a 2, 4 or 8 color screen.\
View both the Display Window data and the application program to\
which it applies at the same time by dragging the CH Screen.
\l
	Preview large pages
\l6	By toggling Word Wrap off, view a page with only the first line of each\
paragraph being visible. Scroll the appropiate paragraph to the top of\
the Display Window, then turn Word Wrap on, to display the entire paragraph.
\l
	Save your preferences
\l6	Set up the program the way you like, then save the configuration.\
The next time you start your configuration will be used.
\l	
\p Overview


	When started, the program accesses the CH Directory and reads in\
CH.cmd, CH.menu, CH.prefs and the Base Files, then goes into\
Standby Mode awaiting the Hot Key. When the user presses the appropriate\
Hot Key combination a Display Window (DW) opens.\
The first time the DW is opened the\
Base Page will be displayed. On subsequent invocations of the DW the\
last page displayed will re-appear. While the DW is active press\
HELP to get a page of program Instructions and their Commands. Executing\
the Close Window Instruction will remove the DW from the screen and put\
the program back into Standby Mode.

	The Data Files are organized by the user into a hierarchal system of\
information Page Groups. The top of the system is the Base Page from\
which a path, through multiple levels, is made to all the other pages\
in the system. Each page is assigned to a group for reference by CH.\
Each group consists of one Parent Page and any number of Child Pages.

	Special characters are used in the Data File to define the beginning\
of pages, create Parent(Menu) Pages, give a Data File name if the\
page is in another file, assign Related Items and control the text\
display appearance. 
\r\Files/Word Wrap Specifiers
\r\Files/Text Style Characters
\r\Files/Page Specifiers
\r\Files/Related Item Specifier

	During each invocation of the DW as you access each page, if\
necessary, it's file is read into memory. When you quit the DW any\
file in memory not necessary to redisplay the current page or any\
Marked pages will be released from memory. All files with Ancestor\
Pages of either the current page or any Marked pages are necessary\
for re-displaying them.

	A Mark provides a way of instantly accessing a particular page at a\
specific line. The function keys (F1 thru F10) are used to display, set\
and clear Marks.
\r\Using/Marks

	A ten page History buffer keeps a chronological record of pages\
accessed. A return to a previous page after Instructions that\
access non-contiguous pages (Mark\
display, multi-level Page Search, Related Item Instruction, etc.) would\
be difficult without the History buffer.
\r\Using/History Buffer

	The Clear Unused Files Instruction allows the clearing of Unused Files from\
memory without quitting the display. A Clear All Files Instruction will clear all\
Marks then clear Unused Files from memory. These Instructions also\
clear the History buffer.
\r\Using/Memory Management

\p Program Limits

\w
Page search string			128
Page search page name		50
Word search string			128
Displayed Line length		255
Pages per group				65,535
Groups							65,533
Pages per file 				no limit
Files 							no limit
Parent-Child levels  		no limit
Displayable lines 			no limit
Lines-Per-Page 				no limit
\W
	Interpret "No Limit" to mean the program sets no limit or the\
program limit exceeds the maximum amount of memory possible.

\p Possible Problems


A. No indications when starting from WorkBench:
\l3	Make sure LIBS: directory contains textfont.library and icon.library.\
Check that you specified an output window in either the CH.prefs file\
or the CH.info file.\
If no output window is specified enter the Hot Key combination,\
the program may already be started.
\l
B.	Can't find the CH.cmd or CH.prefs File:
\l3	CH needs the CH.cmd and CH.prefs files to run. Both of these files\
must be in the CH Directory. The CH Directory may be assigned\
at startup, with the "CHData:" assignment or the current directory, in\
that order of precedence.

\p Future Additions


State Instruction:
	Make it possible to save the current state of the CH program. When\
restarting have CH re-open all files and duplicate the program state.

Edit mode:
	Eliminate the need of using a seperate editor to convert an ASCII\
Text File to a Data File. Perform all editing operations within CH.

ARexx Interface:
	Access to all Commands via ARexx.

Configurable Commands for Marks:
	Not restricting the Mark Commands to using the function keys.

Public screen window:
	Open the DW on any public screen. Use less memory, position DW\
anywhere on the application program's window.
